## libjson-rpc-cpp 0.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(libjson-rpc-cpp)

# list command no longer ignores empty elements 
cmake_policy(SET CMP0007 NEW)
cmake_policy(SET CMP0012 NEW)

if (${CMAKE_MAJOR_VERSION} GREATER 2)
	# old policy do not use MACOSX_RPATH
	cmake_policy(SET CMP0042 OLD)
endif()

set(MAJOR_VERSION 0)
set(MINOR_VERSION 6)
set(PATCH_VERSION 0)
set(SO_VERSION    0)

set(BUILD_SHARED_LIBS YES CACHE BOOL "Build shared libraries")
set(BUILD_STATIC_LIBS NO CACHE BOOL "Build static libraries")
set(LIB_SUFFIX "" CACHE STRING "Suffix for library directory (32/64)")

if (NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
	message(FATAL_ERROR "Both BUILD_SHARED_LIBS and BUILD_STATIC_LIBS are disabled")
endif()

# defaults for modules that can be enabled/disabled
if(UNIX)
        set(UNIX_DOMAIN_SOCKET_SERVER YES CACHE BOOL "Include Unix Domain Socket server")
        set(UNIX_DOMAIN_SOCKET_CLIENT YES CACHE BOOL "Include Unix Domain Socket client")
endif(UNIX)
set(HTTP_SERVER YES CACHE BOOL "Include HTTP server using libmicrohttpd")
set(HTTP_CLIENT YES CACHE BOOL "Include HTTP client support using curl")
set(COMPILE_TESTS YES CACHE BOOL "Compile test framework")
set(COMPILE_STUBGEN YES CACHE BOOL "Compile the stubgenerator")
set(COMPILE_EXAMPLES YES CACHE BOOL "Compile example programs")

# print actual settings
message(STATUS "HTTP_SERVER: ${HTTP_SERVER}")
message(STATUS "HTTP_CLIENT: ${HTTP_CLIENT}")
if(UNIX)
    message(STATUS "UNIXDOMAINSOCKET_SERVER: ${UNIX_DOMAIN_SOCKET_SERVER}")
    message(STATUS "UNIXDOMAINSOCKET_CLIENT: ${UNIX_DOMAIN_SOCKET_CLIENT}")
endif(UNIX)
message(STATUS "COMPILE_TESTS: ${COMPILE_TESTS}")
message(STATUS "COMPILE_STUBGEN: ${COMPILE_STUBGEN}")
message(STATUS "COMPILE_EXAMPLES: ${COMPILE_EXAMPLES}")

# setup directory where we should look for cmake files
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")

# setup compiler settings && dependencies
include(CMakeCompilerSettings)
include(CMakeDependencies)

# setup output directories
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")

if (WIN32)
	set(CMAKE_INSTALL_PREFIX ${PROJECT_BINARY_DIR}/dist)
endif()

# setup global include_directories (for backwards compatibility)
include_directories("${CMAKE_BINARY_DIR}/gen/")
include_directories("${CMAKE_BINARY_DIR}/gen/jsonrpccpp/common")

# the core framework
add_subdirectory(src/jsonrpccpp)

#the stubgenerator
if (COMPILE_STUBGEN)
	add_subdirectory(src/stubgenerator)
endif ()

# setup examples
if (COMPILE_EXAMPLES)
	add_subdirectory(src/examples)
endif()

# setup test suite
if (COMPILE_TESTS)
        enable_testing(true)
	add_subdirectory(src/test)
endif()

# create documentation
if (DOXYGEN_FOUND)
	file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/doc)
	message(STATUS "Found doxygen: ${DOXYGEN_EXECUTABLE}")
	configure_file("${CMAKE_SOURCE_DIR}/doc/doxyfile.in" "${CMAKE_BINARY_DIR}/Doxyfile" @ONLY)
	add_custom_target(doc ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/doc COMMENT "Generating API documentation")
endif(DOXYGEN_FOUND)

# setup uninstall target
configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY
)

add_custom_target(
	uninstall
	COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

# packaging stuff
include(CMakePackaging)

=== src/examples/CMakeLists.txt ===
file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/gen)

add_custom_command(
	OUTPUT ${CMAKE_BINARY_DIR}/gen/abstractstubserver.h
	COMMAND jsonrpcstub ARGS ${CMAKE_CURRENT_SOURCE_DIR}/spec.json --cpp-server=AbstractStubServer --cpp-server-file=${CMAKE_BINARY_DIR}/gen/abstractstubserver.h
	MAIN_DEPENDENCY spec.json
	DEPENDS jsonrpcstub
	COMMENT "Generating Server Stubfiles"
	VERBATIM
)

add_custom_command(
	OUTPUT ${CMAKE_BINARY_DIR}/gen/stubclient.h
	COMMAND jsonrpcstub ARGS ${CMAKE_CURRENT_SOURCE_DIR}/spec.json --cpp-client=StubClient --cpp-client-file=${CMAKE_BINARY_DIR}/gen/stubclient.h
	MAIN_DEPENDENCY spec.json
	DEPENDS jsonrpcstub
	COMMENT "Generating Client Stubfile"
	VERBATIM
)

add_custom_target(common_stubs
	DEPENDS ${CMAKE_BINARY_DIR}/gen/abstractstubserver.h ${CMAKE_BINARY_DIR}/gen/stubclient.h
)

add_custom_command(
	OUTPUT ${CMAKE_BINARY_DIR}/gen/xbmcremote.h
	COMMAND jsonrpcstub ARGS ${CMAKE_CURRENT_SOURCE_DIR}/xbmc_remote.json --cpp-client=XbmcRemoteClient --cpp-client-file=${CMAKE_BINARY_DIR}/gen/xbmcremote.h
	MAIN_DEPENDENCY xbmc_remote.json
	DEPENDS jsonrpcstub
	COMMENT "Generating Client XBMC Stubfile"
	VERBATIM
)

include_directories(..)
include_directories(${CMAKE_BINARY_DIR})
include_directories(${JSONCPP_INCLUDE_DIRS})
include_directories(${MHD_INCLUDE_DIRS})

if(HTTP_SERVER)
    add_executable(simpleserversample simpleserver.cpp)
    target_link_libraries(simpleserversample jsonrpcserver)
endif()

if(HTTP_CLIENT)
    add_executable(simpleclientsample simpleclient.cpp)
    target_link_libraries(simpleclientsample jsonrpcclient)
endif()

if (COMPILE_STUBGEN)
    if(HTTP_CLIENT)
            add_executable(stubclientsample stubclient.cpp ${CMAKE_BINARY_DIR}/gen/stubclient.h)
            target_link_libraries(stubclientsample jsonrpcclient)
        add_executable(xbmcremote xbmcremote.cpp ${CMAKE_BINARY_DIR}/gen/xbmcremote.h)
        target_link_libraries(xbmcremote jsonrpcclient)
    endif()

    if(HTTP_SERVER)
        add_executable(stubserversample stubserver.cpp ${CMAKE_BINARY_DIR}/gen/abstractstubserver.h)
        target_link_libraries(stubserversample jsonrpcserver)
    endif()
endif()

=== src/jsonrpccpp/CMakeLists.txt ===
# setup common headers and sources
file(GLOB jsonrpc_header *.h)
file(GLOB jsonrpc_header_common common/*.h)
file(GLOB jsonrpc_source_common common/*.c*)

# setup server headers and sources
file(GLOB jsonrpc_install_header_server 
	server/requesthandlerfactory.h
	server/abstractserver.h
	server/abstractserverconnector.h
	server/iprocedureinvokationhandler.h
	server/iclientconnectionhandler.h
)
file(GLOB jsonrpc_header_server server/*.h)
file(GLOB jsonrpc_source_server server/*.c*)

# setup client headers and sources
file(GLOB jsonrpc_install_header_client
	client/batchcall.h
	client/batchresponse.h
	client/client.h
	client/iclientconnector.h
)
file(GLOB jsonrpc_header_client client/*.h)
file(GLOB jsonrpc_source_client client/*.c*)

# setup connector variables defaults
set(client_connector_source "")
set(client_connector_header "")
set(client_connector_libs   "")
set(server_connector_source "")
set(server_connector_header "")
set(server_connector_libs   "")

# setup sources for http connectors
if (HTTP_CLIENT)
	list(APPEND client_connector_header "client/connectors/httpclient.h")
	list(APPEND client_connector_source "client/connectors/httpclient.cpp")
	list(APPEND client_connector_libs ${CURL_LIBRARIES})
endif()

if (HTTP_SERVER)
	list(APPEND server_connector_header "server/connectors/httpserver.h")
	list(APPEND server_connector_source "server/connectors/httpserver.cpp")
	list(APPEND server_connector_libs ${CMAKE_THREAD_LIBS_INIT} ${MHD_LIBRARIES})  
endif()

# setup sources for unix domain socket connectors
if (UNIX_DOMAIN_SOCKET_SERVER)
        list(APPEND server_connector_header "server/connectors/unixdomainsocketserver.h")
        list(APPEND server_connector_source "server/connectors/unixdomainsocketserver.cpp")
        list(APPEND server_connector_libs ${CMAKE_THREAD_LIBS_INIT})
endif()

if (UNIX_DOMAIN_SOCKET_CLIENT)
        list(APPEND client_connector_header "client/connectors/unixdomainsocketclient.h")
        list(APPEND client_connector_source "client/connectors/unixdomainsocketclient.cpp")
endif()

# configure a header file to pass some of the CMake settings to the source code
# TODO: move it to custom build step?
file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/gen/jsonrpccpp/common")
configure_file("${CMAKE_SOURCE_DIR}/src/jsonrpccpp/version.h.in" "${CMAKE_BINARY_DIR}/gen/jsonrpccpp/version.h")
configure_file("${PROJECT_SOURCE_DIR}/src/jsonrpccpp/common/jsonparser.h.in" "${PROJECT_BINARY_DIR}/gen/jsonrpccpp/common/jsonparser.h")

install(FILES "${CMAKE_BINARY_DIR}/gen/jsonrpccpp/version.h" DESTINATION include/jsonrpccpp)
install(FILES "${PROJECT_BINARY_DIR}/gen/jsonrpccpp/common/jsonparser.h" DESTINATION include/jsonrpccpp/common)

# include required directories
include_directories(..)
include_directories(${JSONCPP_INCLUDE_DIRS})
include_directories(${MHD_INCLUDE_DIRS})

# setup shared common library
if (BUILD_SHARED_LIBS)
	add_library(jsonrpccommon SHARED ${jsonrpc_source_common} ${jsonrpc_header} ${jsonrpc_helper_source_common})
	target_link_libraries(jsonrpccommon ${JSONCPP_LIBRARIES})
	set_target_properties(jsonrpccommon PROPERTIES OUTPUT_NAME jsonrpccpp-common)
endif()

# setup static common library
if (BUILD_STATIC_LIBS OR MSVC)
	add_library(jsonrpccommonStatic STATIC ${jsonrpc_source_common} ${jsonrpc_header} ${jsonrpc_helper_source_common})
	target_link_libraries(jsonrpccommonStatic ${JSONCPP_LIBRARIES})
	set_target_properties(jsonrpccommonStatic PROPERTIES OUTPUT_NAME jsonrpccpp-common)

	if (NOT BUILD_SHARED_LIBS)
		add_library(jsonrpccommon ALIAS jsonrpccommonStatic)
	endif()
endif()

# setup shared client library
if (BUILD_SHARED_LIBS)
	add_library(jsonrpcclient SHARED ${jsonrpc_source_client} ${jsonrpc_header} ${jsonrpc_header_client} ${client_connector_source})
	add_dependencies(jsonrpcclient jsonrpccommon)
	target_link_libraries(jsonrpcclient jsonrpccommon ${client_connector_libs})
	set_target_properties(jsonrpcclient PROPERTIES OUTPUT_NAME jsonrpccpp-client)
endif()

# setup static client library
if (BUILD_STATIC_LIBS OR MSVC)
	add_library(jsonrpcclientStatic STATIC ${jsonrpc_source_client} ${jsonrpc_header} ${jsonrpc_header_client} ${client_connector_source})
	target_link_libraries(jsonrpcclientStatic jsonrpccommonStatic ${client_connector_libs})
	set_target_properties(jsonrpcclientStatic PROPERTIES OUTPUT_NAME jsonrpccpp-client)

	if (NOT BUILD_SHARED_LIBS)
		add_library(jsonrpcclient ALIAS jsonrpcclientStatic)
	endif()
endif()

# setup shared server library
if (BUILD_SHARED_LIBS)
	add_library(jsonrpcserver SHARED ${jsonrpc_source_server} ${jsonrpc_header} ${jsonrpc_header_server} ${server_connector_source})
	add_dependencies(jsonrpcserver jsonrpccommon)
	target_link_libraries(jsonrpcserver jsonrpccommon ${server_connector_libs})
	set_target_properties(jsonrpcserver PROPERTIES OUTPUT_NAME jsonrpccpp-server)
endif()

# setup static server library
if (BUILD_STATIC_LIBS OR MSVC)
	add_library(jsonrpcserverStatic STATIC ${jsonrpc_source_server} ${jsonrpc_header} ${jsonrpc_header_server} ${server_connector_source})
	target_link_libraries(jsonrpcserverStatic jsonrpccommonStatic ${server_connector_libs})
	set_target_properties(jsonrpcserverStatic PROPERTIES OUTPUT_NAME jsonrpccpp-server)

	if (NOT BUILD_SHARED_LIBS)
		add_library(jsonrpcserver ALIAS jsonrpcserverStatic)
	endif()
endif()

set(ALL_LIBS)

if (BUILD_SHARED_LIBS OR NOT BUILD_STATIC_LIBS)
	list(APPEND ALL_LIBS jsonrpccommon jsonrpcclient jsonrpcserver)
endif()

if (BUILD_STATIC_LIBS OR MSVC)
	list(APPEND ALL_LIBS jsonrpccommonStatic jsonrpcclientStatic jsonrpcserverStatic)
endif()

# setup version
set(VERSION_STRING ${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION})
set_target_properties(
	${ALL_LIBS}
	PROPERTIES VERSION "${VERSION_STRING}" SOVERSION "${SO_VERSION}"
)

# install libraries
install(FILES ${jsonrpc_header}                 DESTINATION include/jsonrpccpp)
install(FILES ${jsonrpc_header_common}          DESTINATION include/jsonrpccpp/common)
install(FILES ${jsonrpc_helper_header_common}   DESTINATION include/jsonrpccpp/common/helper)
install(FILES ${jsonrpc_install_header_client}  DESTINATION include/jsonrpccpp/client)
install(FILES ${jsonrpc_install_header_server}  DESTINATION include/jsonrpccpp/server)
install(FILES ${client_connector_header}        DESTINATION include/jsonrpccpp/client/connectors)
install(FILES ${server_connector_header}        DESTINATION include/jsonrpccpp/server/connectors)

if (WIN32)
	file(GLOB win32_libs ${CMAKE_SOURCE_DIR}/win32-deps/lib/*.dll)
	file(COPY ${win32_libs} DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
	install(FILES ${win32_libs} DESTINATION bin)
	install(DIRECTORY ${CMAKE_SOURCE_DIR}/win32-deps/include DESTINATION .)
endif()

install(TARGETS ${ALL_LIBS}
        LIBRARY DESTINATION lib/${CMAKE_LIBRARY_PATH}
        ARCHIVE DESTINATION lib/${CMAKE_LIBRARY_PATH}
	RUNTIME DESTINATION bin
)

#set pkg-config
get_filename_component(FULL_PATH_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX} ABSOLUTE)
set(FULL_PATH_INCLUDEDIR "${FULL_PATH_INSTALL_PREFIX}/include")
set(FULL_PATH_LIBDIR "${FULL_PATH_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_PATH}")

CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/cmake/libjsonrpccpp-client.pc.cmake ${CMAKE_BINARY_DIR}/libjsonrpccpp-client.pc)
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/cmake/libjsonrpccpp-server.pc.cmake ${CMAKE_BINARY_DIR}/libjsonrpccpp-server.pc)
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/cmake/libjsonrpccpp-common.pc.cmake ${CMAKE_BINARY_DIR}/libjsonrpccpp-common.pc)

INSTALL(FILES 
    "${CMAKE_BINARY_DIR}/libjsonrpccpp-server.pc"
    "${CMAKE_BINARY_DIR}/libjsonrpccpp-client.pc"
    "${CMAKE_BINARY_DIR}/libjsonrpccpp-common.pc"
    DESTINATION "lib/${CMAKE_LIBRARY_PATH}/pkgconfig")

=== src/stubgenerator/CMakeLists.txt ===
file(GLOB_RECURSE jsonrpcstub_source *.cpp)
file(GLOB_RECURSE jsonrpcstub_header *.h)
list(REMOVE_ITEM jsonrpcstub_source "${CMAKE_CURRENT_SOURCE_DIR}/main.cpp")

include_directories(..)
include_directories(${JSONCPP_INCLUDE_DIRS})
include_directories(${ARGTABLE_INCLUDE_DIRS})

set(ALL_LIBS)


if (BUILD_SHARED_LIBS)
        add_library(libjsonrpcstub SHARED ${jsonrpcstub_source} ${jsonrpcstub_header} ${jsonrpc_helper_source_common})
        target_link_libraries(libjsonrpcstub jsonrpccommon ${JSONCPP_LIBRARIES} ${ARGTABLE_LIBRARIES})
        set_target_properties(libjsonrpcstub PROPERTIES OUTPUT_NAME jsonrpccpp-stub)
        list(APPEND ALL_LIBS libjsonrpcstub)
endif()

# setup static common library
if (BUILD_STATIC_LIBS)
        add_library(libjsonrpcstubStatic STATIC ${jsonrpcstub_source} ${jsonrpcstub_header} ${jsonrpc_helper_source_common})
        target_link_libraries(libjsonrpcstubStatic jsonrpccommonStatic ${JSONCPP_LIBRARIES} ${ARGTABLE_LIBRARIES})
        set_target_properties(libjsonrpcstubStatic PROPERTIES OUTPUT_NAME jsonrpccpp-stub)

        if (NOT BUILD_SHARED_LIBS)
                add_library(libjsonrpcstub ALIAS libjsonrpcstubStatic)
        endif()

        list(APPEND ALL_LIBS libjsonrpcstubStatic)
endif()

set(VERSION_STRING ${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION})
set_target_properties(
        ${ALL_LIBS}
        PROPERTIES VERSION "${VERSION_STRING}" SOVERSION "${SO_VERSION}"
)


add_executable(jsonrpcstub main.cpp)
target_link_libraries(jsonrpcstub jsonrpccommon libjsonrpcstub )

#Generate manpage
if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	configure_file("${CMAKE_SOURCE_DIR}/doc/manpage.in" "${CMAKE_BINARY_DIR}/manpage" @ONLY)
	add_custom_command(OUTPUT jsonrpcstub.1.gz
		COMMAND gzip -c "${CMAKE_BINARY_DIR}/manpage" > ${CMAKE_BINARY_DIR}/jsonrpcstub.1.gz
		COMMENT "Generating man pages"
		VERBATIM
	)

	add_custom_target(manpage ALL DEPENDS jsonrpcstub.1.gz)
	install(FILES ${CMAKE_BINARY_DIR}/jsonrpcstub.1.gz DESTINATION share/man/man1/)
	add_dependencies(jsonrpcstub manpage)

endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/cmake/libjsonrpccpp-stub.pc.cmake ${CMAKE_BINARY_DIR}/libjsonrpccpp-stub.pc)

INSTALL(FILES
    "${CMAKE_BINARY_DIR}/libjsonrpccpp-stub.pc"
    DESTINATION "lib/${CMAKE_LIBRARY_PATH}/pkgconfig")

install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/stubgenerator/
        DESTINATION include/jsonrpccpp/stubgen
        FILES_MATCHING PATTERN "*.h")

install(TARGETS jsonrpcstub ${ALL_LIBS} LIBRARY DESTINATION lib${LIB_SUFFIX}
	ARCHIVE DESTINATION lib${LIB_SUFFIX}
	RUNTIME DESTINATION bin
)

=== src/test/CMakeLists.txt ===

set(CTEST_OUTPUT_ON_FAILURE TRUE)

file(GLOB_RECURSE test_source *.cpp)
file(GLOB test_specs *.json)

file(COPY ${CMAKE_SOURCE_DIR}/src/examples/server.key ${CMAKE_SOURCE_DIR}/src/examples/server.pem DESTINATION ${CMAKE_BINARY_DIR})
file(COPY ${CMAKE_SOURCE_DIR}/src/examples/server.key ${CMAKE_SOURCE_DIR}/src/examples/server.pem DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY ${test_specs} DESTINATION ${CMAKE_BINARY_DIR})
file(COPY ${test_specs} DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})

include_directories(..)
include_directories(${CMAKE_BINARY_DIR})
include_directories(${JSONCPP_INCLUDE_DIRS})

if(HTTP_CLIENT AND HTTP_SERVER)
        add_definitions(-DHTTP_TESTING)
else()
        list(REMOVE_ITEM test_source "${CMAKE_CURRENT_SOURCE_DIR}/testhttpserver.cpp")
endif()

if(UNIX_DOMAIN_SOCKET_SERVER AND UNIX_DOMAIN_SOCKET_CLIENT)
    add_definitions(-DUNIXDOMAINSOCKET_TESTING)
endif()

if(COMPILE_STUBGEN)
	add_definitions(-DSTUBGEN_TESTING)
endif()

add_executable(unit_testsuite ${test_source})
target_link_libraries(unit_testsuite jsonrpccommon)
target_link_libraries(unit_testsuite jsonrpcserver)
target_link_libraries(unit_testsuite jsonrpcclient)

if(COMPILE_STUBGEN)
        list(APPEND test_source "${CMAKE_BINARY_DIR}/gen/abstractstubserver.h")
        list(APPEND test_source "${CMAKE_BINARY_DIR}/gen/stubclient.h")
        target_link_libraries(unit_testsuite libjsonrpcstub)
        add_dependencies(unit_testsuite common_stubs)
endif()

add_test(client ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite "[client]")
add_test(server ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite "[server]")
add_test(NAME common WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite "[common]")

if(HTTP_CLIENT AND HTTP_SERVER)
        add_test(NAME connector_http WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite "[connector_http]")
endif()

if (UNIX_DOMAIN_SOCKET_CLIENT AND UNIX_DOMAIN_SOCKET_SERVER)
        add_test(NAME connector_unixdomainsocket WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite "[connector_unixdomainsocket]")
endif()

if(COMPILE_STUBGEN)
        add_test(NAME stubgen WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite "[stubgenerator]")
endif()

if(HTTP_CLIENT AND HTTP_SERVER AND COMPILE_STUBGEN)
        add_test(NAME integration WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite "[integration]")
endif()

add_test(NAME all WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite)

=== debian/changelog ===
libjson-rpc-cpp (0.6.0-2build1) xenial; urgency=medium

  * No-change rebuild for the libjsoncpp transition.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Tue, 09 Feb 2016 16:45:01 +0100

libjson-rpc-cpp (0.6.0-2) unstable; urgency=medium

  * added patch to fix FTBS with GCC5
  * added patch to fix FTBS on armel and armhf
  * d/rules: strip -dev package

 -- Peter Spiess-Knafl <dev@spiessknafl.at>  Tue, 04 Aug 2015 20:22:57 +0200

libjson-rpc-cpp (0.6.0-1) unstable; urgency=medium

  * Imported Upstream version 0.6.0
  * Removed upstream applied patch
  * d/copyright: updated copyright year
  * d/control: changed from libboost-test-dev to catch
  * d/*.dirs: removed no longer required .dirs files
  * d/patches/0001-always-create-manpage.patch: refreshed to avoid fuzz
  * Added new binary packages: libjsonrpccpp-stub0 libjsonrpccpp-stub0-dbg
  * Added patch to fix multiarch support
  * Added patch to fix security warning

 -- Peter Spiess-Knafl <dev@spiessknafl.at>  Sat, 04 Jul 2015 12:57:44 +0200

libjson-rpc-cpp (0.5.0-1) unstable; urgency=medium

  * Imported Upstream version 0.5.0
  * Removed upstream applied patches
  * Updated maintainer-email
  * Adapted debian/rules to build static and shared libraries.
  * Added multiarch support.
  * Applied wrap-and-sort to debian/* files.
  * Removed unused doxygen build dependency.
  * Removed boilerplate stuff from debian/rules.
  * Updated upstream signing key.

 -- Peter Spiess-Knafl <dev@spiessknafl.at>  Sat, 18 Apr 2015 16:56:28 +0200

libjson-rpc-cpp (0.4.2-4) unstable; urgency=medium

  * added always build manpage patch (Closes: #779691)
  * deactivated parallel build (Closes: #779689, #779688)
  * debian/control: added Vcs-Git and Vcs-Browser fields.

 -- Peter Spiess-Knafl <psk@autistici.org>  Thu, 05 Mar 2015 00:06:49 +0100

libjson-rpc-cpp (0.4.2-3) unstable; urgency=medium

  * added upstream patch
  * added further infos about symbols overrides.
  * changed release to unstable.

 -- Peter Spiess-Knafl <psk@autistici.org>  Tue, 27 Jan 2015 00:30:20 +0000

libjson-rpc-cpp (0.4.2-2) experimental; urgency=medium

  * Corrected types in debian/changelog, debian/control
  * Added patch for syntax error in manpage.
  * Changed license to Expat for all files.
  * Reduced the upstream signing key size.

 -- Peter Spiess-Knafl <psk@autistici.org>  Fri, 23 Jan 2015 00:21:46 +0000

libjson-rpc-cpp (0.4.2-1) experimental; urgency=medium

  * Imported Upstream version 0.4.2
  * Removed upstream applied patch

 -- Peter Spiess-Knafl <psk@autistici.org>  Wed, 21 Jan 2015 19:56:37 +0000

libjson-rpc-cpp (0.4.1-2) experimental; urgency=medium

  * Added dbg packages for client, common and server library. 
  * Overrode no-symbols-control-file, because we use shlibs instead.
  * Changed target from unstable to experimental, due to freeze phase.

 -- Peter Spiess-Knafl <psk@autistici.org>  Mon, 29 Dec 2014 02:58:23 +0000

libjson-rpc-cpp (0.4.1-1) unstable; urgency=medium

  * New upstream release.

 -- Peter Spiess-Knafl <psk@autistici.org>  Mon, 01 Dec 2014 17:55:34 +0000

libjson-rpc-cpp (0.4-2) unstable; urgency=medium

  * Added signature checking to debian/watch

 -- Peter Spiess-Knafl <psk@autistici.org>  Mon, 01 Dec 2014 12:36:37 +0000

libjson-rpc-cpp (0.4-1) unstable; urgency=medium

  * Initial release. (Closes: #770410)

 -- Peter Spiess-Knafl <psk@autistici.org>  Fri, 21 Nov 2014 00:59:55 +0000

=== debian/control ===
Source: libjson-rpc-cpp
Priority: optional
Maintainer: Peter Spiess-Knafl <dev@spiessknafl.at>
Build-Depends: catch,
               cmake,
               debhelper (>= 9),
               libargtable2-dev,
               libcurl4-openssl-dev | libcurl4-nss-dev,
               libjsoncpp-dev,
               libmicrohttpd-dev
Standards-Version: 3.9.6
Section: libs
Homepage: https://github.com/cinemast/libjson-rpc-cpp
Vcs-Git: git://anonscm.debian.org/collab-maint/libjson-rpc-cpp.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/libjson-rpc-cpp.git

Package: libjsonrpccpp-common0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libjsonrpccpp-client0 (= ${binary:Version}),
          libjsonrpccpp-server0 (= ${binary:Version}),
          libjsonrpccpp-tools (= ${binary:Version})
Description: common functionality for server and client library
 This library provides common classes for the libjson-rpc-cpp framework like
 .
  * Exceptions
  * Error-Codes
  * Specification Parsers and Writers
  * Procedure parameter validation
 .
 This package usually only makes sense with libjsonrpccpp-client0 and/or
 libjsonrpccpp-server0.

Package: libjsonrpccpp-common0-dbg
Architecture: any
Depends: libjsonrpccpp-common0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Section: debug
Priority: extra
Description: debugging symbols for libjsonrpccpp-common0
 This library provides common classes for the libjson-rpc-cpp framework like
 .
  * Exceptions
  * Error-Codes
  * Specification Parsers and Writers
  * Procedure parameter validation
 .
 This package usually only makes sense with libjsonrpccpp-client0 and/or
 libjsonrpccpp-server0.
 .
 This package contains the debugging symbols for libjsonrpccpp-common0.

Package: libjsonrpccpp-client0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libjsonrpccpp-tools
Description: library implementing json-rpc C++ clients
 This library provides classes to easily implement JSON-RPC C++ clients.
 It comes with a built in HTTP-Client connector (based on libcurl)
 for easy data exchange. It is fully JSON-RPC 2.0 and JSON-RPC
 1.0 compatible, including:
 .
  * Type checking
  * Error response handling
  * Batch procedure calls
  * JSON-RPC Method invocation
  * JSON-RPC Notification invocation
  * Interface for additional Client-Connectors beside HTTP
  * Positional and named parameters

Package: libjsonrpccpp-client0-dbg
Architecture: any
Depends: libjsonrpccpp-client0 (= ${binary:Version}),
         libjsonrpccpp-common0-dbg (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Section: debug
Priority: extra
Description: debugging symbols for libjsonrpccpp-client0
 This library provides classes to easily implement JSON-RPC C++ clients.
 It comes with a built in HTTP-Client connector (based on libcurl)
 for easy data exchange. It is fully JSON-RPC 2.0 and JSON-RPC 1.0 compatible,
 including:
 .
  * Type checking
  * Error response handling
  * Batch procedure calls
  * JSON-RPC Method invocation
  * JSON-RPC Notification invocation
  * Simple Interface for implementing additional Client-Connectors beside HTTP
  * Positional and named parameters
 .
 This package contains the debugging symbols for libjsonrpccpp-client0.

Package: libjsonrpccpp-server0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libjsonrpccpp-tools
Description: library implementing json-rpc C++ servers
 This library provides classes to easily implement JSON-RPC C++ Server
 applications. It comes with a built in HTTP-Server connector
 (based on libmicrohttpd) for easy data exchange. It is fully JSON-RPC 2.0 and
 JSON-RPC 1.0 compatible, including:
 .
  * Type checking
  * Malformed request handling
  * Handling batch procedure calls
  * JSON-RPC Method invocation
  * JSON-RPC Notification invocation
  * Simple Interface for implementing additional Server-Connectors beside HTTP
  * Positional and named parameters

Package: libjsonrpccpp-server0-dbg
Architecture: any
Depends: libjsonrpccpp-common0-dbg (= ${binary:Version}),
         libjsonrpccpp-server0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Section: debug
Priority: extra
Description: debugging symbols for libjsonrpccpp-server0
 This library provides classes to easily implement JSON-RPC C++ Server
 applications. It comes with a built in HTTP-Server connector
 (based on libmicrohttpd) for easy data exchange. It is fully JSON-RPC 2.0 and
 JSON-RPC 1.0 compatible, including:
 .
  * Type checking
  * Malformed request handling
  * Handling batch procedure calls
  * JSON-RPC Method invocation
  * JSON-RPC Notification invocation
  * Simple Interface for implementing additional Server-Connectors beside HTTP
  * Positional and named parameters
 .
 This package contains the debugging symbols for libjsonrpccpp-server0.

Package: libjsonrpccpp-stub0
Architecture: any
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: libjsonrpccpp-common0, ${misc:Depends}, ${shlibs:Depends}
Suggests: libjsonrpccpp-tools
Description: library for stub generation of libjsonrpccpp based applications
 This package provides the stub generator library for the libjson-rpc-cpp
 framework. It can automatically generate full functioning C++ and JavaScript
 JSON-RPC Client classes, which are ready to use.
 .
 For JSON-RPC Server applications, this library can generate an abstract C++
 class which just has to be sub classed and implement all pure virtual methods.
 To make this possible, a interface description file (in the JSON format)
 is required, which lists all available methods with corresponding parameters
 and types.

Package: libjsonrpccpp-stub0-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libjsonrpccpp-common0-dbg (= ${binary:Version}),
         libjsonrpccpp-stub0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: libjsonrpccpp-tools
Description: debugging symbols for libjsonrpccpp-stub0
 This package provides the stub generator library for the libjson-rpc-cpp
 framework. It can automatically generate full functioning C++ and JavaScript
 JSON-RPC Client classes, which are ready to use.
 .
 For JSON-RPC Server applications, this library can generate an abstract C++
 class which just has to be sub classed and implement all pure virtual methods.
 To make this possible, a interface description file (in the JSON format)
 is required, which lists all available methods with corresponding parameters
 and types.
 .
 This package contains the debugging symbols for libjsonrpccpp-common0.

Package: libjsonrpccpp-tools
Architecture: any
Section: libdevel
Depends: libjsonrpccpp-stub0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: libjsonrpccpp-dev
Description: stub generator for libjsonrpccpp based applications
 This package provides the stub generator for the libjson-rpc-cpp framework.
 It can automatically generate full functioning C++ and JavaScript JSON-RPC
 Client classes, which are ready to use.
 .
 For JSON-RPC Server applications, this tool can generate an abstract C++ class
 which just has to be sub classed and implement all pure virtual methods. To
 make this possible, a simple interface description file (in the JSON format)
 is required, which lists all available methods with corresponding parameters
 and types.

Package: libjsonrpccpp-dev
Section: libdevel
Architecture: any
Depends: libjsonrpccpp-client0 (= ${binary:Version}),
         libjsonrpccpp-common0 (= ${binary:Version}),
         libjsonrpccpp-server0 (= ${binary:Version}),
         libjsonrpccpp-stub0 (= ${binary:Version}),
         ${misc:Depends}
Description: development files for JSON-RPC C++ framework
 This package provides all required developer resources like header-files
 and statically linked libraries of the libjson-rpc-cpp framework.
 .
 Features of this framework include:
 .
  * Type checking
  * Malformed request handling
  * Handling batch procedure calls
  * JSON-RPC Method invocation
  * JSON-RPC Notification invocation
  * Simple Interface for implementing additional Server-Connectors beside HTTP
  * Positional and named parameters
